local tablet = AceLibrary("Tablet-2.0")
local parser = AceLibrary("Parser-3.0")
local BC = AceLibrary("Babble-Class-2.2")
local roster = AceLibrary("Roster-2.1")

local L = AceLibrary("AceLocale-2.2"):new("Violation")

Violation = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceHook-2.1", "AceDB-2.0", "AceConsole-2.0", "AceComm-2.0", "FuBarPlugin-2.0")
local Violation = Violation

local coloredNames = setmetatable({}, {__index =
	function(self, key)
		local class = select(2, UnitClass(key))
		if not class then
			self[key] = "|cffffffff" .. key .. "|r"
		else
			self[key] = "|cff" .. BC:GetHexColor(class) .. UnitName(key) .. "|r"
		end
		return self[key]
	end
})

local data = nil
local _G = getfenv(0)

function Violation:OnEnable()
	Violation:Reset()
	parser:Register({ eventType = "Damage" }, self.OnCombatEvent, self)
end

function Violation:OnTooltipUpdate()
	local cat = tablet:AddCategory(
		"columns", 2
	)
	for k, v in pairs(data) do
		cat:AddLine("text", coloredNames[k], "text2", tostring(v or 0))
	end
end

function Violation:OnCombatEvent(t)
	if t.amount and t.sourceName then
		if not data[t.sourceName] then
			data[t.sourceName] = 0
		end
		data[t.sourceName] = data[t.sourceName] + t.amount
		--self:Print(data.player .. ":" .. t.sourceName)
		self:UpdateTooltip()
	end
end

function Violation:Reset()
	data = {}
end

